﻿using Infragistics.Windows.DataPresenter;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfApplication2
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.ViewModel  = new TableViewModel();

        }

        public TableViewModel ViewModel
        {
            get
            {
                return DataContext as TableViewModel;
            }
            set
            {
                this.DataContext = value;
                InitFields();
            }

        }

        private void InitFields()
        {

            if (ViewModel != null)
            {                
                FieldLayout layout = this.Grid.FieldLayouts.FirstOrDefault();
                if (layout != null && layout.Fields != null)
                {
                                            
                    layout.Fields.Clear();
                    for (int i = 0; i < ViewModel.Rows.Count(); i++)
                    {
                        layout.Fields.Add(CreateUnboundField(label: "Column " + i, fieldName: "Columns[" + i + "]", cellStyle: Resources["InfoStyle"] as Style));
                    }
                }
            }
        }

        private static UnboundField CreateUnboundField(string fieldName, Type dataType = null, string label = "", bool editable = false, double? width = null, string name = "", Style cellStyle = null)
        {
            UnboundField field = new UnboundField { Label = label };

            Binding binding = new Binding(fieldName);
            binding.UpdateSourceTrigger = UpdateSourceTrigger.PropertyChanged;
            binding.Mode = BindingMode.TwoWay;
            field.Binding = binding;

            if (dataType != null)
            {
                field.DataType = dataType;
            }
            if (cellStyle != null)
            {
                field.Settings.CellValuePresenterStyle = cellStyle;
            }
            field.Settings.AllowEdit = editable;
            return field;
        }
    }
}
